//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1  Blue
#property indicator_color2  Red

//
//
//
//
//

extern string TimeFrame     = "current time frame";
extern int    FasterMA      = 12;
extern int    FasterMode    = MODE_EMA;
extern int    SlowerMA      = 26;
extern int    SlowerMode    = MODE_EMA;
extern int    MAPrice       = PRICE_CLOSE;
extern bool alertsOn        = false;
extern bool alertsOnCurrent = true;
extern bool alertsMessage   = true;
extern bool alertsSound     = false;
extern bool alertsEmail     = false;

//
//
//
//
//

double CrossUp[];
double CrossDown[];
double State[];
int    timeFrame;
string indicatorFileName;
bool   returnBars;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(3);
   SetIndexBuffer(0, CrossUp);   SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 233);
   SetIndexBuffer(1, CrossDown); SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 234);
   SetIndexBuffer(2, State);
      indicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame=="returnBars"); if (returnBars) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);
   return(0);
}
int deinit() { return(0); }

//
//
//
//
//

int start() {
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { CrossUp[0] = limit+1; return(0); }
         if (timeFrame!=Period()) limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));

   //
   //
   //
   //
   //
   
   for(i=limit; i>=0; i--)
   {
      CrossUp[i]   = EMPTY_VALUE;
      CrossDown[i] = EMPTY_VALUE;
      State[i]     = State[i+1];

      int y = iBarShift(NULL,timeFrame,Time[i]);
      int x = iBarShift(NULL,timeFrame,Time[i+1]);
      if (x==y) continue;
      
         double range  = iATR(NULL,0,10,i);
         double maFast = iMA(NULL,timeFrame,FasterMA,0,FasterMode,MAPrice,y);
         double maSlow = iMA(NULL,timeFrame,SlowerMA,0,SlowerMode,MAPrice,y);

            if (maFast>maSlow) State[i] =  1;
            if (maFast<maSlow) State[i] = -1;
            if (State[i] != State[i+1])
            if (State[i] == 1)
                  CrossUp[i]   = Low[i] -range/2.0;
            else  CrossDown[i] = High[i]+range/2.0;
   }
   
   //
   //
   //
   //
   //
   
      if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; whichBar = iBarShift(NULL,0,iTime(NULL,timeFrame,whichBar));
      if (State[whichBar] != State[whichBar+1])
      {
         if (State[whichBar] ==  1) doAlert(whichBar,"up");
         if (State[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
   return(0);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
 
void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(timeFrameToString(timeFrame)," ",Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," fast ma crossed slow ma ",doWhat);
             if (alertsMessage) Alert(message);
             if (alertsEmail)   SendMail(StringConcatenate(Symbol(),"MA line cross"),message);
             if (alertsSound)   PlaySound("alert2.wav");
      }
}

